-- phpMyAdmin SQL Dump
-- version 2.8.1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Erstellungszeit: 05. Januar 2007 um 06:58
-- Server Version: 5.0.22
-- PHP-Version: 5.2.0
--
-- Datenbank: `aseco211`
--

CREATE DATABASE `aseco211`;
USE `aseco211`;

-- --------------------------------------------------------

--
-- Tabellenstruktur fr Tabelle `challenges`
--

CREATE TABLE `challenges` (
  `Id` mediumint(11) NOT NULL auto_increment,
  `Uid` varchar(35) collate utf8_unicode_ci NOT NULL,
  `Name` varchar(100) collate utf8_unicode_ci NOT NULL,
  `Author` varchar(100) collate utf8_unicode_ci NOT NULL,
  `Environment` varchar(15) collate utf8_unicode_ci NOT NULL,
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `Uid` (`Uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur fr Tabelle `players`
--

CREATE TABLE `players` (
  `Id` mediumint(11) NOT NULL auto_increment,
  `Login` varchar(100) collate utf8_unicode_ci NOT NULL,
  `Game` varchar(4) collate utf8_unicode_ci NOT NULL,
  `NickName` varchar(100) collate utf8_unicode_ci NOT NULL,
  `Nation` varchar(60) collate utf8_unicode_ci NOT NULL,
  `UpdatedAt` datetime NOT NULL default '0000-00-00 00:00:00',
  `Wins` mediumint(9) NOT NULL default '0',
  `TimePlayed` mediumint(9) NOT NULL default '0',
  `TeamName` char(100) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `Login` (`Login`),
  KEY `Game` (`Game`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur fr Tabelle `records`
--

CREATE TABLE `records` (
  `Id` mediumint(11) NOT NULL auto_increment,
  `ChallengeId` mediumint(9) NOT NULL default '0',
  `PlayerId` mediumint(9) NOT NULL default '0',
  `Score` mediumint(9) NOT NULL default '0',
  `Date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `ChallengeId` (`ChallengeId`,`PlayerId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Tabellenstruktur fr Tabelle `votes`
--

CREATE TABLE `votes` (
  `Id` int(11) NOT NULL auto_increment,
  `Score` smallint(6) NOT NULL default '0',
  `PlayerId` mediumint(9) NOT NULL default '0',
  `ChallengeId` mediumint(9) NOT NULL default '0',
  PRIMARY KEY  (`Id`),
  UNIQUE KEY `PlayerId` (`PlayerId`,`ChallengeId`),
  KEY `ChallengeId` (`ChallengeId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;
