<?php
class About extends Plugin {
  
  private $openwindows;
  
  function showAbout($command) {
    global $first_mem_usage;
    
    if ($this->existsPlayerData($command['author'], 'window')) {
      $window = $this->getPlayerData($command['author'], 'window');
      $window->maximize();
    } else {
      $days = floor($this->Aseco->getUptime()/(3600*24));
      $hours = floor(($this->Aseco->getUptime()%(3600*24))/3600);
      $mins = floor((($this->Aseco->getUptime()%(3600*24))%3600)/60);
      $window = $this->createWindowToPlayerFramework('About Aseco', 1, 0.45, $command['author']);
      $window->setContent('<line><cell><text>Aseco is a dedicated server tool for Trackmania.'.LF.'You can use it to save best times on tracks.'.LF.'Also it makes it possible for the caretaker of the server to add new features.'.LF.'These features are just plugins that need to be included into the Aseco installation.'.LF.'The current Aseco version contains a Manialink Framework that manages all'.LF.'windows that appear on your screen.'.LF.'Current versions of the tool can be downloaded at the $f00$l[http://www.sourceforge.net/projects/aseco]Project\'s Website$l'.LF.'</text></cell></line>
      <line><cell><text>Aseco is running for $o'.$days.' days, '.$hours.' hours and '.$mins.' minutes'.LF.'$zVersion Number: $o'.ASECO_VERSION.LF.'$zMemory Usage: $o'.round(memory_get_usage()/1024, 1).'kb</text></cell></line>');
      $window->addCallback('close', 'closeAbout');
      $this->storePlayerData($command['author'], 'window', $window);
    }
  }
  
  function closeAbout($param, $window, $player) {
    $this->removePlayerData($player, 'window');
  }
  
  function showAboutToPlayer($player) {
    $this->showAbout(array('author' => $player));
  }
  
  function init() {
    $statusbar = $this->Aseco->getPlugin('Statusbar');
    if ($statusbar) {
      $statusbar->addButton('About', $this, 'showAboutToPlayer', 0.09);
    }
  }
}

$_PLUGIN = new About();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('about', 'showAbout', 'shows information about Aseco');
$_PLUGIN->setDescription('Displays information about Aseco, for those who are playing on an Aseco server for the first time.');
$_PLUGIN->addEvent('onSync', 'init');
?>