<?php
class TmxLinker extends Plugin {
  private $orig_msgs;
  
  function replaceMsgs($skip) {
    $this->modifyMessage('RECORD_NONE', 1);
    $this->modifyMessage('RECORD_CURRENT', 1);
  }
  
  function modifyMessage($message, $param_nb) {
    if (!isset($this->orig_msgs[$message])) $this->orig_msgs[$message] = $this->Aseco->getChatMessage($message);
    $text = $this->orig_msgs[$message];
    $text = str_replace('{'.$param_nb.'}', '$l[http://united.tm-exchange.com/main.aspx?action=trackshow&uid='.$this->Aseco->server->challenge->uid.'#auto]{'.$param_nb.'}$l$z', $text);
    $this->Aseco->setChatMessage($message, $text);
  }
}

$_PLUGIN = new TmxLinker();
$_PLUGIN->setAuthor('Florian Schnell');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->setDescription('Replaces all track names with links to Trackmania Exchange.');
$_PLUGIN->addEvent('onNewChallenge', 'replaceMsgs');
$_PLUGIN->addEvent('onSync', 'replaceMsgs');
?>