<?php
/**
 * Chat plugin.
 * Vote for a track and display current score of it.
 */

class AdminMsgs extends Plugin
	{
	function adminmsg(&$command)
		{
		$command['params'] = explode(" ", $command['params'], 2);
		$m = '{#error}-pm-$z[Admin$z] {#interact}'.$command['params'][1];
		$msg = $this->Aseco->formatColors($m);
		$this->sendServerMessageToLogin($command['params'][0], $msg);
		$m = '{#error}-pm-$z[sent to: ' . $command['params'][0] . '$z] {#interact}'.$command['params'][1];
		$msg = $this->Aseco->formatColors($m);
		$this->sendServerMessageToLogin($command['author']->login, $msg);
		}  //  adminmsg

	function adminchat(&$command)
		{
		$m = '{#error}-Admin Chat-$z['.$command['author']->nickname.'$z] {#interact}'.$command['params'];
		$msg = $this->Aseco->formatColors($m);
		foreach($this->Aseco->server->players->player_list as $player_item)
			{
			if($this->Aseco->isAdmin($player_item->login))
				{
				$this->sendServerMessageToLogin($player_item->login, $msg);
				}
			}
		}  //  adminchat

	function adminsay(&$command)
		{
		$m = '[Admin] {#interact}'.$command['params'];
		$msg = $this->Aseco->formatColors($m);
		$this->sendServerMessage($msg);
		}  //  adminsay
	}

$_PLUGIN = new AdminMsgs();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->setDescription('Admin message commands');
$_PLUGIN->addChatCommand('admin msg', 'adminmsg', 'Send administrative msg to a player (/admin msg login message)');
$_PLUGIN->addChatCommand('admin chat', 'adminchat', 'Send msg to all current admins (/admin chat message)');
$_PLUGIN->addChatCommand('admin say', 'adminsay', 'Send msg to all players as anonymous admin (/admin say message)');
?>
