<?php
/*
 Original version by Mistral (wrong attribution removed)
 hack/slash/general mayhem for aseco 1.0x by AssemblerManiac
 */

class RaspPlayerAdmin extends Plugin
	{
	function chatPlayers(&$command)
		{
		$player = $command['author'];
		$command['params'] = explode(' ', $command['params']);
		$wildcard = $command['params'][0];

		if ( isset($player->data['w_players']) )
			{
			$player->data['w_players']->maximize();
			return;
			}

		if ($this->Aseco->isAdmin($command['author']->login))
			$this->playerAdmin($command, $wildcard);
		else
			$this->playerList($command, $wildcard);
		}

	function onCloseWin($clickvalue, &$window, &$player)
		{
		unset($player->data['w_players']);
		}  //  onCloseWin

	// show a short list of players, no admin functions
	function playerList(&$command, &$wildcard)
		{
		$content = array();
		$header = "<line height='.02'><cell width='0.94'></cell></line>
					<line height='.04'>
					<cell width='0.47' bgcolor='888E'><text halign='right'>Login</text></cell>
					<cell width='0.47' bgcolor='888E'><text>  NickName</text></cell></line>";

		$detail = "<line>
					<cell width='0.47'><text textcolor='EEEE' halign='right'>{LOGIN}</text></cell>
					<cell width='0.47'><text textcolor='EEEE'>  {NICKNAME}</text></cell></line>";
		$msg = '';
		$player = $command['author'];
		$ctr1 = 0;
		foreach($this->Aseco->server->players->player_list as $pl)
			{
			if ( strlen($command['params'][0]) == 0 ||
				 stripos(stripFormatting($pl->nickname), $wildcard) > 0 ||
				 stripos($pl->login, $wildcard) > 0)
				{
				$s = $detail;
				$s = str_replace('{LOGIN}', $pl->login, $s);
				$s = str_replace('{NICKNAME}', htmlspecialchars($pl->nickname), $s);
				$ctr1++;
				$msg .= $s;
				if ( $ctr1 > 20 )
					{
					$ctr1 = 0;
					$content[] = $header . $msg;
					$msg = '';
					}
				}
			}

		if ( strlen($msg) > 0 )
			{
			$ctr1 = 0;
			$content[] = $header . $msg;
			}

		if ( sizeof($content) == 0 )
			{
			$this->Aseco->client->query('ChatSendServerMessageToLogin', 'No matches found', $command['author']->login);
			return;
			}

    	$window = $this->createWindowToPlayerFramework('Player List', .94, 1.1, $player);
//		if ($player->data['PA']['bg_light'])
//			$bg='BBBE';
//		else
			$bg='222E';

		$window->setBackground($bg);
		$window->setContent($content);
		$window->addCallback('close', 'onCloseWin');
		$player->data['w_players'] = $window;
		}

	function playerAdmin(&$command, $wildcard)
		{
		$player = $command['author'];
		$content = $this->buildPages($command, $wildcard);
		if ( sizeof($content) == 0 )
			{
			$this->Aseco->client->query('ChatSendServerMessageToLogin', 'No matches found', $command['author']->login);
			return;
			}

    	$window = $this->createWindowToPlayerFramework('Player Admin', 1.1, 1, $command['author']);
		if ($player->data['PA']['bg_light'])
			$bg='BBBE';
		else
			$bg='222E';

		$window->setBackground($bg);
		$window->setContent($content);
		$window->addCallback('ignore', 'playerIgnore');
		$window->addCallback('nick', 'showNick');
		$window->addCallback('color', 'bgColor');
		$window->addCallback('guest', 'playerGuest');
		$window->addCallback('warn', 'playerWarn');
		$window->addCallback('kick', 'playerKick');
		$window->addCallback('ban', 'playerBan');
		$window->addCallback('black', 'playerBlackList');
		$window->addCallback('close', 'onCloseWin');
		$command['author']->data['w_players'] = $window;

		}  //  playerAdmin

	function buildPages($command, $wildcard)			// returns a $contents array for sending to a new, or changed, window
		{
		$admin = $command['author'];

		if ( !isset($admin->data['PA']) )
			{
			$admin->data['PA'] = array();
			$admin->data['PA']['bg_light'] = true;
			$admin->data['PA']['show_nick'] = true;
			}

		$admin->data['PA']['wildcard'] = $wildcard;
		$header = "<line height='.02'><cell></cell></line>
				<line height='.04'>";

		if ($admin->data['PA']['bg_light'])
			$nickbg = 'BBBE';
		else
			$nickbg = '222E';

		if ($admin->data['PA']['show_nick'])
			$header .= 	"<cell width='0.3' bgcolor='444F'><text halign='center' action='{name:nick,param:0}'>\$0F0Nickname\$z\$s/Login</text></cell>";
		else
			$header .= 	"<cell width='0.3' bgcolor='444F'><text halign='center' action='{name:nick,param:1}'>Nickname/\$0F0Login\$z\$s</text></cell>";
		$header .= "<cell width='0.1' bgcolor='888E'></cell>";
		$header .= "<cell width='0.2' bgcolor='888E'><text halign='center'>Guest</text></cell>
					<cell width='0.3' bgcolor='888E'></cell>";
		if ($admin->data['PA']['bg_light'])
			$header .= "<cell width='0.2' bgcolor='222E'><text halign='center' action='{name:color,param:0}' textcolor='BBB'>DARK</text></cell></line>";
		else
			$header .= "<cell width='0.2' bgcolor='BBBE'><text halign='center' action='{name:color,param:1}' textcolor='222'>LIGHT</text></cell></line>";
		$header.="<line height='.02'><cell></cell></line>";

		$header .= "<line height='0.003'><cell width='1.1' bgcolor='fff8'></cell></line>";

		$this->Aseco->client->query('GetGuestList', 100, 0);
		$guests = $this->Aseco->client->getResponse();

		$this->Aseco->client->query('GetIgnoreList', 100, 0);
		$ignored = $this->Aseco->client->getResponse();

		$pl_list = array();
		$ctr = 1;
		$i = 0;

		$pages = array();

		foreach($this->Aseco->server->players->player_list as $pl)
			{
			if ( ! (strlen($command['params'][0]) == 0 ||
				 stripos(stripFormatting($pl->nickname), $wildcard) > 0 ||
				 stripos($pl->login, $wildcard) > 0) )
				continue;

			$isguest = false;
			foreach ($guests as $guest)
				{
				if ($pl->login == $guest['Login'])
					{
					$isguest = true;
					break;
					}
				}

			$isignored = false;
			foreach ($ignored as $ignore)
				{
				if ($pl->login == $ignore['Login'])
					{
					$isignored = true;
					break;
					}
				}

			$pl_list[$ctr] = array('login'=>$pl->login, 'guest'=>$isguest, 'ignore'=>$isignored, 'nickname'=>$pl->nickname);

			if ($admin->data['PA']['show_nick'])
				$showname = htmlspecialchars($pl->nickname);
			else
				$showname = $pl->login;

			$content.="<line height='.04'>";
			$content.="<cell bgcolor='{$nickbg}' width='0.4'><text halign='left'> " . $showname . '$z$s</text></cell>';
			$gt='$F00Add';
			if ($isguest)
				$gt='$0F0Remove';
			$content.="<cell width='0.1'><text halign='center' action='{name:guest,param:" . $ctr . "}'>" . $gt . '</text></cell>';
			$content.="<cell width='0.12'><text halign='center' action='{name:warn,param:" . $ctr . "}' textcolor='FF0'>Warn</text></cell>";
			$ig="F80'>Ignore";
			if ($isignored)
				$ig="0F0'>Unignore";
			$content.="<cell width='0.12'><text halign='center' action='{name:ignore,param:" . $ctr . "}' textcolor='".$ig.'</text></cell>';
			$content.="<cell width='0.12'><text halign='center' action='{name:kick,param:" . $ctr . "}' textcolor='88f'>Kick</text></cell>";
			$content.="<cell width='0.12'><text halign='center' action='{name:ban,param:" . $ctr . "}' textcolor='44f'>Ban</text></cell>";
			$content.="<cell width='0.12'><text halign='center' action='{name:black,param:" . $ctr . "}' textcolor='00F'>Black</text></cell>";
			$content.="</line>";
			$content.="<line height='0.003'><cell width='1.1' bgcolor='fff8'></cell></line>";

			$i++;
			if ( $i > 20 )
				{
				$i = 0;
				$pages[] = $header . $content;
				$content = '';
				}
			$ctr++;
			}
		if ( strlen($content) > 0 )
			{
			$pages[] = $header . $content;
			}

		$admin->data['PA']['list'] = $pl_list;

		return $pages;
		}

	function reDisplay(&$window, &$player)
		{
		$cmd['author'] = $player;
		$cmd['params'] = $player->data['PA']['wildcard'];
		$content = $this->buildPages($cmd, $wildcard);
		if ( sizeof($content) == 0 )
			{
			$window->close();
			}
		else
			{
			$window->setContent($content);
			$window->show();
			}
		}  //  redisplay

	function showNick($clickvalue, &$window, &$player)
		{
		$player->data['PA']['show_nick'] = $clickvalue;
		$this->reDisplay($window, $player);
		}  //  showNick

	function bgColor($clickvalue, &$window, &$player)
		{
		$player->data['PA']['bg_light'] = $clickvalue;

//		if ($player->data['PA']['bg_light'])
//			$bg='BBBE';
//		else
//			$bg='222E';

//		$window->setBackground($bg);
		$this->reDisplay($window, $player);
		}  //  bgColor


	function playerWarn($clickvalue, &$window, &$player)
		{
		$who = $player->data['PA']['list'][$clickvalue];
		$login = $who['login'];

		$cr = "\n";
		$message =	'$s$F00This is an administrative warning.' . $cr . $cr .
						'$z$sYou have done something against our server\'s policy. Not respecting other players,' . $cr . 'or using offensive language might result in a $F00kick, or ban $z$88F$sthe next time.' . $cr . $cr .
						'$z$sThe server administrators.';
		$this->sendPopupWindowToPlayer($login, $message, "WARNING");

		$message = formatText('{#server}>> Admin warned {1}', $who['nickname']);
		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$window->show();

		}  //  playerWarn


	function playerGuest($clickvalue, &$window, &$player)
		{
		$who = $player->data['PA']['list'][$clickvalue];
		$login = $who['login'];
		$nickname = $who['nickname'];
		if ($who['guest'])
			{
			$this->Aseco->client->query('RemoveGuest', $login);
			$message = formatText('{#server}>> Admin removed {1} {#server}from guestlist!', $nickname);
			}
		else
			{
			$this->Aseco->client->query('AddGuest', $login);
			$message = formatText('{#server}>> Admin added {1} {#server}to guestlist!', $nickname);
			}

		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$this->reDisplay($window, $player);
		}

	function playerIgnore($clickvalue, &$window, &$player)
		{
		$who = $player->data['PA']['list'][$clickvalue];
		$login = $who['login'];
		$nickname = $who['nickname'];
		if ($who['ignore'])
			{
			$this->Aseco->client->query('UnIgnore', $login);
			$message = formatText('{#server}>> Admin removed {1} {#server}from the ignore list!', $nickname);
			}
		else
			{
			$this->Aseco->client->query('Ignore', $login);
			$message = formatText('{#server}>> Admin added {1} {#server}to the ignore list!', $nickname);
			}

		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$this->reDisplay($window, $player);
		}

	// Kick
	function playerKick($clickvalue, &$window, &$player)
		{
		$who = $player->data['PA']['list'][$clickvalue];
		$login = $who['login'];
		$nickname = $who['nickname'];
		$this->Aseco->client->query('Kick', $login);
		$message = formatText('{#server}>> Admin kicked {1}{#server}!', $nickname);
		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$this->reDisplay($window, $player);
		}

	// Ban
	function playerBan($clickvalue, &$window, &$player)
		{
		$who = $player->data['PA']['list'][$clickvalue];
		$login = $who['login'];
		$nickname = $who['nickname'];
		$this->Aseco->client->query('Ban', $login);
		$this->Aseco->client->query('Kick', $login);
		$message = formatText('{#server}>> Admin banned {1}{#server}!', $nickname);
		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$this->reDisplay($window, $player);
		}

	// Blacklist
	function playerBlackList($clickvalue, &$window, &$player)
		{
		$who = $player->data['PA']['list'][$clickvalue];
		$login = $who['login'];
		$nickname = $who['nickname'];
		$this->Aseco->client->query('BlackList', $login);
		$this->Aseco->client->query('Kick', $login);
		$message = formatText('{#server}>> Admin blacklisted {1}{#server}!', $nickname);
		$message = $this->Aseco->formatColors($message);
		$this->Aseco->client->query('ChatSendServerMessage', $message);

		$this->reDisplay($window, $player);
		}
	}

$_PLUGIN = new RaspPlayerAdmin();
$_PLUGIN->setAuthor('Assembler Maniac');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->addChatCommand('players', 'chatPlayers', 'Shows list of players on server');
?>
