<?php
class AutoKick2 extends Plugin
	{
private $isEnabled;
private $chatter;
private $finisher;
private $checkpointer;
private $mapnumber;
private $debug;

function loadkicker()
		{
		$settings = $this->Aseco->xml_parser->parseXML('settings/autokick2.xml');
		$settings = $settings['SETTINGS'];
		$this->isEnabled = $settings['KICK_ENABLED'][0];
		$this->mapnumber = $settings['CHALLENGES'][0];
		$this->chatter = $settings['USE_CHAT'][0];
		$this->finisher = $settings['USE_FINISH'][0];
		$this->checkpointer = $settings['USE_CPS'][0];
		$this->debug = $settings['DEBUG'][0];
		$this->Aseco->console('AutoKick2 plugin initialized.');
		$this->Aseco->client->query('ChatSendServerMessage', '$z$b$s$w$777AutoKick2 plugin initialized.$z');
		$junk = $this->Aseco->client->getResponse();
		return;
		}

function playerInit(&$player)
		{
		if($this->isEnabled == 'no') 
		return;
		if($player->login == '')
		return;
		$player->idleCount=(int)0;
	//print_r($player); echo CRLF;
		return;
		}

function kickIdleNewChallenge(&$challenge)
		{
		if($this->isEnabled == 'no') 
		return;
		foreach($this->Aseco->server->players->player_list as $key => $players)
		{
		$players->idleCount = $players->idleCount+1;
		if($this->debug == 'no')
		return;
		$this->Aseco->console('AutoKick debug:'.' '. $players->login .' '.'set to' .' '. $players->idleCount);
	//print_r($players); echo CRLF;
		return;
		}
}
function kickIdleChat(&$data)
		{
	//print_r($data[1]); echo CRLF;
		if($this->isEnabled == 'no') 
		return;
		if($this->chatter == 'no') 
		return;
		$id = $data[0];
 		if ($id == 0)
 		return;
		$login = $data[1];
		$this->Aseco->server->players->getplayer($login)->idleCount = $this->Aseco->server->players->getplayer($login)->idleCount=(int)0;
		}

function kickIdleCheckpoint(&$data)
		{
	//print_r($data[1]); echo CRLF;
		if($this->isEnabled == 'no') 
		return;
		if($this->checkpointer == 'no') 
		return;
		$login = $data[1];
		$this->Aseco->server->players->getplayer($login)->idleCount = $this->Aseco->server->players->getplayer($login)->idleCount=(int)0;
		}

function kickIdleFinish(&$finish_item) 
		{
	//print_r($finish_item->player->login); echo CRLF;
		if($this->isEnabled == 'no') 
		return;
		if($this->finisher == 'no') 
		return;
		$finish_item->player->idlecount = $finish_item->player->idlecount=(int)0;
		}

function kickIdlePlayers(&$challenge)
		{
		if($this->isEnabled == 'no') 
		return;
		foreach($this->Aseco->server->players->player_list as $key => $player)
		{
	//print_r($player);
		if($player->spectatorstatus == true) 
		return;
		if($player->isreferee == true) 
		return;
		if($this->mapnumber <= $player->idleCount)
		{
		$this->Aseco->client->query('Kick', $player->login, 'You have been Kicked after '. $this->mapnumber .' races being idle');
		$junk = $this->Aseco->client->getResponse();
		$this->Aseco->client->query('ChatSendServerMessage', '$z$fc0player -$fff'.' '. $player->nickname .' '.'$z$fc0has been kicked after$fff'.' '. $this->mapnumber .' '.'$z$fc0idle races');
		$junk = $this->Aseco->client->getResponse();
		return;
		}
	  }
      }
}
$_PLUGIN = new AutoKick2();
$_PLUGIN->setAuthor('CavalierDeVache');
$_PLUGIN->setVersion(1.0);
$_PLUGIN->setDescription('Kicks inactive players after a set number of challenges, Original by Mistral');
$_PLUGIN->addEvent('onStartup', 'loadkicker');
$_PLUGIN->addEvent('onPlayerConnect', 'playerInit');
$_PLUGIN->addEvent('onEndRace', 'kickIdlePlayers');
$_PLUGIN->addEvent('onNewChallenge', 'kickIdleNewChallenge');
$_PLUGIN->addEvent('onChat', 'kickIdleChat');
$_PLUGIN->addEvent('onCheckpoint', 'kickIdleCheckpoint');
$_PLUGIN->addEvent('onPlayerFinish', 'kickIdleFinish');
$_PLUGIN->addChatCommand('admin reloadkicker', 'loadkicker', 'Reload AutoKick2 settings from autokick2.xml');
$_PLUGIN->setWebsite('http://www.tm-slowpokes.com');
?>
