<?php
class SimpleMusic extends Plugin
	{
	private $isEnabled;
	private $songlist;
	private $url;
	private $force_music;
	private $shutit;
	private $downbaby;

	function loadMusic()
		{
		$settings = $this->Aseco->xml_parser->parseXML('settings/music_server.xml');
		$settings = $settings['SETTINGS'];
		$this->isEnabled = $settings['MUSIC_ON'][0];
		$this->songlist = $settings['SONG_FILES'][0]['SONG'];
		$this->url = $settings['MUSIC_SERVER'][0];
		$this->force_music = (bool)$settings['FORCE_MUSIC'][0];
		$this->Aseco->console('SimpleMusic plugin initialized.');
		$this->Aseco->client->query('ChatSendServerMessage', '$z$b$s$w$777SimpleMusic plugin initialized.$z');
		$junk = $this->Aseco->client->getResponse();
		return;
		}

	function playMusic(&$command)
		{
		shuffle($this->songlist);
		$random_song = $this->url . $this->songlist[array_rand($this->songlist)];
		$this->shutit = (bool)null;
		$this->downbaby = "";
		if($this->isEnabled=='yes')
		{
		$this->Aseco->client->query('SetForcedMusic', $this->force_music, $random_song);
		$junk = $this->Aseco->client->getResponse();
		}
		elseif($this->isEnabled=='no')
		{
		$this->Aseco->client->query('SetForcedMusic', $this->shutit, $this->downbaby);
		$junk = $this->Aseco->client->getResponse();
		return;
		}
	}
}	
$_PLUGIN = new SimpleMusic();
$_PLUGIN->setAuthor('CavalierDeVache');
$_PLUGIN->setVersion(1.3);
$_PLUGIN->setDescription('Sends custom music to racers');
$_PLUGIN->addChatCommand('admin reloadmusic', 'loadMusic', 'Reload songlist and settings from music_server.xml');
$_PLUGIN->addEvent('onStartup', 'loadMusic');
$_PLUGIN->addEvent('onNewChallenge', 'playMusic');
$_PLUGIN->setWebsite('http://www.tm-slowpokes.com');
?>
