<?php
/**
 * Contains information to the
 * current game which is played.
 */
class Gameinfo {
  var $mode;
  var $chattime;

  // returns current game mode as string.
  function getMode() {
    switch ($this->mode) {
      case 0:
        return "Rounds";
        break;
      case 1:
        return "TimeAttack";
        break;
      case 2:
        return "Team";
        break;
      case 3:
        return "Laps";
        break;
      case 4:
        return "Stunts";
        break;
      case 5:
        return "Cup";
        break;
      default:
        return "Undefined";
        break;
    }
  }

  function Gameinfo($rpc_infos = null) {
    if($rpc_infos) {
      $this->mode = $rpc_infos['GameMode'];
      $this->chattime = $rpc_infos['ChatTime'];
    }
  }
}
?>
