<?php
/**
 * Stores basic information of the server
 * Aseco is running on.
 */
class Server {
  private $game;
  var $ip;
  var $port;
  var $login;
  var $pass;
  var $status;
  var $challenge;
  var $players;
  var $admins;
  var $gameinfo;

  function getGame() {
    switch ($this->game) {
      case "TmForever":
      case "TmUnited.":
      case "TmUnited":
        return "TMU";
      case "TmNationsESWC":
        return "TMN";
      case "TmSunrise":
        return "TMS";
      case "TmOriginal":
        return "TMO";
      default:
        return "Unknown";
    }
  }

  function setGame($in_game) {
    $this->game = $in_game;
  }

  function Server($ip, $port, $login, $pass) {
    $this->ip = $ip;
    $this->port = $port;
    $this->login = $login;
    $this->pass = $pass;
  }
}
?>
